public class Car implements Cloneable
{
	private int yearOfMake;
	private Engine theEngine;
	// Try making the following field final.
	/* final */ private int uniqueID;
	private static int idCount = 0;

	public Car(int year, Engine e)
	{
		yearOfMake = year;
		theEngine = e;	
		uniqueID = idCount++;	
	}

	public String toString()
	{
		return super.toString() + " : " + yearOfMake + " : " + theEngine.toString();
	}

	public Object clone() throws CloneNotSupportedException
	{
		Car other = (Car) super.clone();
		// other is a shallow copy. Let's fix it.
		
		other.theEngine = (Engine) theEngine.clone();
		other.uniqueID = idCount++;
		return other;
	}
}